Crypto++ 8.1 Free C++ class library of cryptographic schemes

Public Types | Public Member Functions | List of all members
AbstractEuclideanDomain< T > Class Template Referenceabstract

Abstract Euclidean domain. More...

Inheritance diagram for AbstractEuclideanDomain< T >:

## Public Types
typedef T | Element
Public Types inherited from AbstractRing< T >
typedef T | Element
Public Types inherited from AbstractGroup< T >
typedef T | Element

## Public Member Functions
virtual void | DivisionAlgorithm (Element &r, Element &q, const Element &a, const Element &d) const =0
| Performs the division algorithm on two elements in the ring. More...
virtual const Element & | Mod (const Element &a, const Element &b) const =0
| Performs a modular reduction in the ring. More...
virtual const Element & | Gcd (const Element &a, const Element &b) const
| Calculates the greatest common denominator in the ring. More...
Public Member Functions inherited from AbstractRing< T >
| AbstractRing ()
| Construct an AbstractRing.
| AbstractRing (const AbstractRing &source)
| Copy construct an AbstractRing. More...
AbstractRing & | operator= (const AbstractRing &source)
| Assign an AbstractRing. More...
virtual bool | IsUnit (const Element &a) const =0
| Determines whether an element is a unit in the group. More...
virtual const Element & | MultiplicativeIdentity () const =0
| Retrieves the multiplicative identity. More...
virtual const Element & | Multiply (const Element &a, const Element &b) const =0
| Multiplies elements in the group. More...
virtual const Element & | MultiplicativeInverse (const Element &a) const =0
| Calculate the multiplicative inverse of an element in the group. More...
virtual const Element & | Square (const Element &a) const
| Square an element in the group. More...
virtual const Element & | Divide (const Element &a, const Element &b) const
| Divides elements in the group. More...
virtual Element | Exponentiate (const Element &a, const Integer &e) const
| Raises a base to an exponent in the group. More...
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO. More...
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Exponentiates a base to multiple exponents in the Ring. More...
virtual const AbstractGroup< T > & | MultiplicativeGroup () const
| Retrieves the multiplicative group. More...
Public Member Functions inherited from AbstractGroup< T >
virtual bool | Equal (const Element &a, const Element &b) const =0
| Compare two elements for equality. More...
virtual const Element & | Identity () const =0
| Provides the Identity element. More...
virtual const Element & | Add (const Element &a, const Element &b) const =0
| Adds elements in the group. More...
virtual const Element & | Inverse (const Element &a) const =0
| Inverts the element in the group. More...
virtual bool | InversionIsFast () const
| Determine if inversion is fast. More...
virtual const Element & | Double (const Element &a) const
| Doubles an element in the group. More...
virtual const Element & | Subtract (const Element &a, const Element &b) const
| Subtracts elements in the group. More...
virtual Element & | Accumulate (Element &a, const Element &b) const
| TODO. More...
virtual Element & | Reduce (Element &a, const Element &b) const
| Reduces an element in the congruence class. More...
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
| Performs a scalar multiplication. More...
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO. More...
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Multiplies a base to multiple exponents in a group. More...

## Detailed Description

### template<class T>
class AbstractEuclideanDomain< T >

Abstract Euclidean domain.

Template Parameters

  T | element class or type

`const Element&` returned by member functions are references to internal data members. Since each object may have only one such data member for holding results, the following code will produce incorrect results:

        abcd = group.Add(group.Add(a,b), group.Add(c,d));

But this should be fine:

        abcd = group.Add(a, group.Add(b, group.Add(c,d));

Definition at line 276 of file algebra.h.

## Member Function Documentation

## ◆ DivisionAlgorithm()

template<class T>

virtual void AbstractEuclideanDomain< T >::DivisionAlgorithm | ( | Element & | r,
|  | Element & | q,
|  | const Element & | a,
|  | const Element & | d
| ) |  | const
| pure virtual

Performs the division algorithm on two elements in the ring.

Parameters

  r | the remainder
  q | the quotient
  a | the dividend
  d | the divisor

Implemented in RingOfPolynomialsOver< T >, EuclideanDomainOf< T >, and EuclideanDomainOf< PolynomialMod2 >.

## ◆ Mod()

template<class T >

const T & AbstractEuclideanDomain< T >::Mod | ( | const Element & | a,
|  | const Element & | b
| ) |  | const
| pure virtual

Performs a modular reduction in the ring.

Parameters

  a | the element
  b | the modulus

Returns
  the result of `ab`.

Implemented in RingOfPolynomialsOver< T >, EuclideanDomainOf< T >, and EuclideanDomainOf< PolynomialMod2 >.

Definition at line 49 of file algebra.cpp.

## ◆ Gcd()

template<class T >

const T & AbstractEuclideanDomain< T >::Gcd | ( | const Element & | a,
|  | const Element & | b
| ) |  | const
| virtual

Calculates the greatest common denominator in the ring.

Parameters

  a | the first element
  b | the second element

Returns
  the the greatest common denominator of a and b.

Definition at line 56 of file algebra.cpp.

The documentation for this class was generated from the following files:

- algebra.h
- algebra.cpp